#ifndef HEURISTIC_H
#define HEURISTIC_H

#include <vector>

class Operator;
class State;

class Heuristic {
    enum {NOT_INITIALIZED = -2};
    int heuristic;
    std::vector<const Operator *> preferred_operators;
protected:
    enum {DEAD_END = -1};
    virtual void initialize() {}
    virtual int compute_heuristic(const State &state) = 0;
    void set_preferred(const Operator *op);
public:
    Heuristic();
    virtual ~Heuristic();

    void evaluate(const State &state);
    bool is_dead_end();
    int get_heuristic();
    void get_preferred_operators(std::vector<const Operator *> &result);
    virtual bool dead_ends_are_reliable() {return true;}
};

#endif
