#!/usr/bin/ruby

require "open3"
require "fileutils"
include Open3

goal = ARGV[0]
domainFile = ARGV[1]
instanceFile = ARGV[2]
runtimeCutoff = ARGV[3]
runlengthCutoff = ARGV[4]
seed = ARGV[5]

# parse parameters
args = ARGV[6..ARGV.length-1]

memoryLimit = nil
useResourceLimits = true
runOutputFile = "./runOutput"

params = ""
args.each_index { |i|
	if (i%2 == 0) 
		paramName = args[i]
		value = args[i+1]

		if (paramName == "-triomemory")
			if (value == "1")
				params = params+"-nomutex "	
			elsif (value == "2")
				params = params+"-lowmemory "
			end
		elsif (paramName == "-nonuniform_random")
			if (value == "1")
				params = params+"-nonuniform_random "
			end
		elsif (paramName == "-maximize")
			if (value == "1")
				params = params+"-maximize "
			end
		elsif (paramName == "-static_noise")
			if (value == "1")
				params = params+"-static_noise "
			end
		elsif (paramName == "-lagrange")
			if (value == "1")
				params = params+"-lagrange "
			end
		elsif (paramName == "-verifyinit")
			if (value == "1")
				params = params+"-verifyinit "
			end
		elsif (paramName == "-verifyAf")
			if (value == "1")
				params = params+"-verifyAf "
			end
		elsif (paramName == "-relaxed_examination")
			if (value == "1")
				params = params+"-relaxed_examination "
			end
		elsif (paramName == "-ri_list")
			if (value == "1")
				params = params+"-ri_list "
			end
		elsif (paramName == "-no_hcut_neighb")
			if (value == "1")
				params = params+"-no_hcut_neighb "
			end
		elsif (paramName == "-ncut_neighb")
			if (value == "1")
				params = params+"-ncut_neighb "
			end
		elsif (paramName == "-no_lcut_neighb")
			if (value == "1")
				params = params+"-no_lcut_neighb "
			end
		elsif (paramName == "-twalkplan")
			if (value == "1")
				params = params+"-twalkplan "
			end
		elsif (paramName == "-walkplan")
			if (value == "1")
				params = params+"-walkplan "
			end
		elsif (paramName == "-notabu_act")
			if (value == "1")
				params = params+"-notabu_act "
			end
		elsif (paramName == "-notabu_fct")
			if (value == "1")
				params = params+"-notabu_fct "
			end
		elsif (paramName == "-remove_act_next_step")
			if (value == "1")
				params = params+"-remove_act_next_step "
			end
		elsif (paramName == "-zero_num_A")
			if (value == "1")
				params = params+"-zero_num_A "
			end
		elsif (paramName == "-penalize_inconsistence")
			if (value == "1")
				params = params+"-penalize_inconsistence "
			end
		elsif (paramName == "-cri_insertion_add_mutex")
			if (value == "1")
				params = params+"-cri_insertion_add_mutex "
			end
		elsif (paramName == "-extended_effects_evaluation")
			if (value == "1")
				params = params+"-extended_effects_evaluation "
			end
		elsif (paramName == "-mutex_and_additive_effects")
			if (value == "1")
				params = params+"-mutex_and_additive_effects "
			end
		elsif (paramName == "-not_supported_preconds_evaluation")
			if (value == "1")
				params = params+"-not_supported_preconds_evaluation "
			end
		elsif (paramName == "-not_extended_unsupported_facts")
			if (value == "1")
				params = params+"-not_extended_unsupported_facts "
			end
		elsif (paramName == "-extended_unsupported_goals")
			if (value == "1")
				params = params+"-extended_unsupported_goals "
			end
		elsif (paramName == "-no_insert_threated_act_in_neighb")
			if (value == "1")
				params = params+"-no_insert_threated_act_in_neighb "
			end
		elsif (paramName == "-relaxed_neighborhood_evaluation")
			if (value == "1")
				params = params+"-relaxed_neighborhood_evaluation "
			end
		elsif (paramName == "-fast_best_action_evaluation")
			if (value == "1")
				params = params+"-fast_best_action_evaluation "
			end
		elsif (paramName == "-stop_remove_act")
			if (value == "1")
				params = params+"-stop_remove_act "
			end
		elsif (paramName == "-consider_relaxed_plan_for_inconsistences")
			if (value == "1")
				params = params+"-consider_relaxed_plan_for_inconsistences "
			end
		elsif (paramName == "-no_mutex_with_additive_effects")
			if (value == "1")
				params = params+"-no_mutex_with_additive_effects "
			end
		elsif (paramName == "-evaluate_mutex_for_action_remotion")
			if (value == "1")
				params = params+"-evaluate_mutex_for_action_remotion "
			end
		elsif (paramName == "-inst_duplicate_param")
			if (value == "1")
				params = params+"-inst_duplicate_param "
			end
		elsif (paramName == "-numeric_neighbors_in_down_levels")
			if (value == "1")
				params = params+"-numeric_neighbors_in_down_levels "
			end
		elsif (paramName == "-donot_try_suspected_actions")
			if (value == "1")
				params = params+"-donot_try_suspected_actions "
			end
		elsif (paramName == "-choose_min_numA_fact")
			if (value == "1")
				params = params+"-choose_min_numA_fact "
			end
		elsif (paramName == "-improve_reachability")
			if (value == "1")
				params = params+"-improve_reachability "
			end
		elsif (paramName == "-vicinato")
		elsif (paramName == "-initializeichoice")
		elsif (paramName == "-lpar")
			params = params+"-lpar_cut_neighb #{value} "
		elsif (paramName == "-ncut")
			params = params+"-ncut_neighb -npar_cut_neighb #{value} "
		elsif (paramName == "-no_cut")
			if (value == "1")
				params = params+"-no_lcut_neighb -no_hcut_neighb "
			end
		elsif (paramName == "-hpar")
			params = params+"-hpar_cut_neighb #{value} "
		elsif (paramName == "-no_pruning")
			if (value == "1")
				params = params+"-no_pruning "
			end
		elsif (paramName == "--useResourceLimits")
			if (value == "false")
				useResourceLimits = false
			end
		elsif (paramName == "--memoryLimit")
			memoryLimit = value
		elsif (paramName == "--runOutputFile")
			runOutputFile = value
			if (runOutputFile[0] != "/"[0])
				runOutputFile = "../../#{runOutputFile}"
			end
		else
			params = params+paramName+" "+value+" "
		end
	end
}

tmpDir = "HAL_#{rand(10000000000)}"
while (File.exists?("SCRATCH/#{tmpDir}"))
	tmpDir = "HAL_#{rand(100000000000)}"
end

FileUtils.mkdir_p "SCRATCH/#{tmpDir}"

FileUtils.cd "SCRATCH/#{tmpDir}"
FileUtils.ln_s("../../algorithms/lpg/lpg", "./lpg")

Signal.trap("TERM") do
	puts "Request to terminate..."
	FileUtils.cd "../../"
	FileUtils.remove_dir "SCRATCH/#{tmpDir}"
	Process.exit(1)
end

domainRedirect = ""
if (domainFile[0] != "/"[0])
	domainRedirect = "../../"
end

instanceRedirect = ""
if (instanceFile[0] != "/"[0])
	instanceRedirect = "../../"
end

numGenerate = 1
if (goal == "quality")
	numGenerate = 10000
end

limitString = ""
if (useResourceLimits)
	memoryLimit = memoryLimit.to_i*1024
	ulimitCutoff = runtimeCutoff.to_i+1
	limitString = "ulimit -t #{ulimitCutoff} -v #{memoryLimit}; "
end

command = "#{limitString}./lpg -o #{domainRedirect}#{domainFile} -f #{instanceRedirect}#{instanceFile} -n #{numGenerate} -seed #{seed} -cputime #{runtimeCutoff} -out #{runOutputFile} #{params}"

puts "Running #{command}"
puts "args ##(#{params})##"

numSolutions = 0
solutionQuality = 1000000000000
errorNotices = 0
exitCode = 0

IO.popen(command) { |io|
	while (line = io.gets)
		if (line =~ /.*Solution number:.*/)
			numSolutions = numSolutions+1
		elsif (line =~ /.*Segmentation Fault.*/)
			errorNotices = errorNotices+1
			if (exitCode == 0)
				exitCode = 1
			end
		elsif (line =~ /.*Exit code:\s*([0-9]*).*/)
			exitCode = $1.to_i
		elsif (line =~ /.*Total time:\s*([0-9\.]*).*/)
			puts "Solution found at time: #{$1}"
		elsif (line =~ /.*Actions:\s*([0-9\.]*).*/)
			puts "Solution cost: #{$1}"
			solutionQuality = $1
		end
	end
}

exitCode = $?.to_i

FileUtils.cd "../../"
FileUtils.remove_dir "SCRATCH/#{tmpDir}"

if (numSolutions > 0)
	puts "Solution cost: #{solutionQuality}"
elsif (errorNotices > 1 || (exitCode > 0 && exitCode != 137))
	puts "CRASHED"
	Process.exit(exitCode)
else (numSolutions == 0)
	puts "TIMEOUT"
end

Process.exit(0)
