#!/bin/bash
# Author: M. Vallati
# script for Building the list of planners to run with macros

DIR_PLANNERS=$1
DIR_DOMAINS=$2
SRC_LIGHT=$3
DOVE_RUN_QUAL=$5
FILE=$4

rm $FILE > /dev/null 2>&1

if [ ! -d $DOVE_RUN_QUAL ]; then
        mkdir $DOVE_RUN_QUAL
fi

planners=`find $DIR_PLANNERS -maxdepth 1 -mindepth 1`
domains=`find $DIR_DOMAINS -maxdepth 1 -mindepth 1 -type d`
count=0

for insieme in $domains; do
	posizione=`basename $insieme`
	for pianificatore in $planners; do
		pian=`basename $pianificatore`
		if [[ "$pian" !=  "planner_Macroff.sh"  &&  "$pian" !=  "planner_paramils.sh" ]]; then
			dominio=`find data/learning/$pian/ -maxdepth 1 -mindepth 1 -name "domain*.pddl"`
			#echo $problemi
			for singolo_d in $dominio; do
				let count=$count+1
				echo "$SRC_LIGHT run -s $pianificatore -d $singolo_d -p $insieme/bootstrap -o $DOVE_RUN_QUAL/$count$posizione">> $FILE	
			done
		else
			if [[ "$pian" =  "planner_Macroff.sh" ]]; then
				dominio=data/learning/$pian/domain.pddl
				macro=`find data/learning/$pian/ -maxdepth 1 -mindepth 1 -name "$posizione.macros.filtered.top.*"`
				if [[ ! -z $macro ]]; then
					for mac in $macro; do
						let count=$count+1
                                		echo "$SRC_LIGHT run -s $pianificatore -m $mac -d $dominio -p $insieme/bootstrap -o $DOVE_RUN_QUAL/$count$posizione">> $FILE
					done
				else
					echo "$SRC_LIGHT run -s $pianificatore -d $dominio -p $insieme/bootstrap -o $DOVE_RUN_QUAL/$count$posizione">> $FILE
				fi
			else
				#paramils
				dominio=data/learning/$pian/domain.pddl
				configurazione=`find data/learning/$pian/ -maxdepth 1 -mindepth 1 -name "*.txt"`
				if [[ ! -z $configurazione ]]; then
					for conf in $configurazione; do
						let count=$count+1
						echo "$SRC_LIGHT run -s $pianificatore -m $conf -d $dominio -p $insieme/bootstrap -o $DOVE_RUN_QUAL/$count$posizione">> $FILE
					done
				fi
			fi
		fi
	done
done

#echo $planners
#echo $Dirdomains
