function createNewExperimentForm(options) {
	var newExperimentForm = $('<form></form>');
	
	var newExperimentFormAllContents = $('<div></div>');
	newExperimentFormAllContents.addClass('formContent');
	
	newExperimentFormAllContents.append(newExperimentForm);
	newExperimentFormAllContents.hide();
	
	var newExperimentContents = $('<div></div>');
	newExperimentForm.append(newExperimentContents);
	
	// Launch/cancel buttons
	var newExperimentFormButtons = $('<div></div>');
	newExperimentFormButtons.addClass('center');
	
	var newExperimentLaunchButton = $('<input></input>');
	newExperimentLaunchButton.attr('type', 'button');
	newExperimentLaunchButton.attr('value', 'Submit');
	newExperimentLaunchButton.click(function() {
		newExperimentLaunchButton.attr('disabled', true);
		
		var spinnerDiv = $('<div></div>');
		spinnerDiv.addClass('spinner');
		spinnerDiv.addClass('center');
		spinnerDiv.html($('<img></img').attr('src', '/hal/commands/getFile/web/icons/ajax-loader.gif').attr('alt', 'Loading. Please wait.'));
		
		newExperimentStatusMessages.removeClass('alert').removeClass('error');
		newExperimentStatusMessages.addClass('success');
		newExperimentStatusMessages.html(spinnerDiv);
		newExperimentStatusMessages.show();
		
		var formData = newExperimentForm.serialize();
		formData['hal_httpResponseContentType'] = 'json';

		$.post('/hal/processFormSnippet/experiment/launchExperiment', formData, function(response) {
			newExperimentLaunchButton.attr('disabled', false);

			if (response.successful) {
				newExperimentStatusMessages.removeClass('alert').removeClass('error');
				newExperimentStatusMessages.addClass('success');
				newExperimentStatusMessages.addClass('center');
				newExperimentStatusMessages.html('New experiment '+reponse.experimentName+' was launched successfully!');
				newExperimentStatusMessages.show();
				
				if ($('#formParent').children().size() > 1) {
					$('#formParent').children().last().slideUp();
					$('#formParent').children().last().remove();
					$('#formParent').children().last().slideDown();					
				} else {
					setTimeout("window.location.href = '/hal/'", 1000);
				}
			} else {
				disableFormElementsUnder(newExperimentForm);
				enableFormElementsUnder(newExperimentFormButtons);
				
				newExperimentStatusMessages.removeClass('alert').removeClass('success');
				newExperimentStatusMessages.addClass('error');
				
				newExperimentStatusMessages.html(response.errorMessage);
				newExperimentStatusMessages.show();
			}
		}, 'json');
	});
	
	var newExperimentSaveButton = $('<input></input>');
	newExperimentSaveButton.attr('type', 'button');
	newExperimentSaveButton.attr('value', 'Save as ready to launch');
	newExperimentSaveButton.click(function() {
		newExperimentSaveButton.attr('disabled', true);
		
		var spinnerDiv = $('<div></div>');
		spinnerDiv.addClass('spinner');
		spinnerDiv.addClass('center');
		spinnerDiv.html($('<img></img').attr('src', '/hal/commands/getFile/web/icons/ajax-loader.gif').attr('alt', 'Loading. Please wait.'));
		
		newExperimentStatusMessages.removeClass('alert').removeClass('error');
		newExperimentStatusMessages.addClass('success');
		newExperimentStatusMessages.html(spinnerDiv);
		newExperimentStatusMessages.show();
		
		var formData = newExperimentForm.serialize();
		formData['hal_httpResponseContentType'] = 'json';

		$.post('/hal/processFormSnippet/experiment/saveExperiment', formData, function(response) {
			newExperimentLaunchButton.attr('disabled', false);

			if (response.successful) {
				newExperimentStatusMessages.removeClass('alert').removeClass('error');
				newExperimentStatusMessages.addClass('success');
				newExperimentStatusMessages.addClass('center');
				newExperimentStatusMessages.html('New experiment '+reponse.experimentName+' was saved successfully!');
				newExperimentStatusMessages.show();
				
				if ($('#formParent').children().size() > 1) {
					$('#formParent').children().last().slideUp();
					$('#formParent').children().last().remove();
					$('#formParent').children().last().slideDown();					
				} else {
					setTimeout("window.location.href = '/hal/'", 1000);
				}
			} else {
				disableFormElementsUnder(newExperimentForm);
				enableFormElementsUnder(newExperimentFormButtons);
				
				newExperimentStatusMessages.removeClass('alert').removeClass('success');
				newExperimentStatusMessages.addClass('error');
				
				newExperimentStatusMessages.html(response.errorMessage);
				newExperimentStatusMessages.show();
			}
		}, 'json');
	});
	
	var newExperimentCancelButton = $('<input></input>');
	newExperimentCancelButton.attr('type', 'button');
	newExperimentCancelButton.attr('value', 'Cancel');
	newExperimentCancelButton.click(cancelForm);
	
	newExperimentFormButtons.append($('<hr>'));
	newExperimentFormButtons.append(newExperimentLaunchButton);
	newExperimentFormButtons.append(newExperimentSaveButton);
	newExperimentFormButtons.append(newExperimentCancelButton);
	
	newExperimentForm.append(newExperimentFormButtons);
	//////
	
	// Status monitoring
	var newExperimentStatusMessages = $('<div></div>');
	newExperimentStatusMessages.hide();
	
	newExperimentForm.append(newExperimentStatusMessages);
	//////
	
	options.target.append(newExperimentFormAllContents);
	
	newExperimentFormAllContents.show();
}