function numberOfProperties(object) {
	if (object === undefined) {
		return 0;
	} else {
		var count = 0;
		
		for (var key in object) {
			count = count+1;
		}
		
		return count;
	}
}

function cancelForm() {
	var formParentChildren = $('#formParent').children();
	
	if (formParentChildren.size() > 1) {
		formParentChildren.last().slideUp();
		formParentChildren.last().remove();
		formParentChildren.last().slideDown();
	} else {
		window.location.href = '/hal/';
	}
}

function enableFormElementsUnder(target) {
	target.find('input').attr('disabled', false);
	target.find('select').attr('disabled', false);
	target.find('textarea').attr('disabled', false);
}

function disableFormElementsUnder(target) {
	target.find('input').attr('disabled', true);
	target.find('select').attr('disabled', true);
	target.find('textarea').attr('disabled', true);
}

function createMultipleFeatureSelector(options) {
	var featureContainer = $('<div></div>');
	
	var numFeatures = 0;
	var numFeaturesField = $('<input></input>');
	numFeaturesField.attr('type', 'hidden');
	numFeaturesField.attr('name', options.idPrefix+'numberOfFeatures');
	numFeaturesField.attr('id', options.idPrefix+'numberOfFeatures');
	numFeaturesField.attr('value', numFeatures);
	
	var addFeatureButton = $('<input></input>');
	addFeatureButton.attr('id', options.idPrefix+'addFeatureButton');
	addFeatureButton.attr('type', 'button');
	addFeatureButton.attr('value', 'Add feature');
	addFeatureButton.click(function(){
		var newFeatureDiv = $('<div></div>');
		featureContainer.append(newFeatureDiv);
		
		createFeatureSelector({
			'target' : newFeatureDiv,
			'idPrefix' : options.idPrefix+'feature_'+numFeatures+'_',
			'features' : options.features,
			'removable' : true
		});
		
		numFeatures = numFeatures+1;
		numFeaturesField.val(numFeatures);
	});
	
	options.target.append(featureContainer);
	options.target.append(numFeaturesField);
	options.target.append(addFeatureButton);
}

function createFeatureSelector(options) {
	var featureLabel = $('<label></label>');
	featureLabel.attr('for', options.idPrefix+'featureName');
	featureLabel.html('Feature');
	
	var featureField = $('<select></select>');
	featureField.attr('id', options.idPrefix+'featureName');
	featureField.attr('name', options.idPrefix+'featureName');
	
	for (var i in options.features) {
		var opt = $('<option></option>');
		opt.attr('value', options.features[i]);
		opt.html(options.features[i]);
		
		featureField.append(opt);
	}
	
	var removeFeatureButton = $('<input></input>');
	removeFeatureButton.attr('type', 'button');
	removeFeatureButton.attr('value', 'Remove');
	removeFeatureButton.click(function() {
		$(this).parent().parent().remove();
	});
	
	var featureSelectionContainer = $('<div></div>');
	featureSelectionContainer.addClass('formElement');
	
	featureSelectionContainer.append(featureLabel);
	featureSelectionContainer.append(featureField);
	featureSelectionContainer.append(removeFeatureButton);
	
	var featureValueLabel = $('<label></label>');
	featureValueLabel.attr('for', options.idPrefix+'featureValue');
	featureValueLabel.html('Value');
	
	var featureValueField = $('<input></input>');
	featureValueField.attr('id', options.idPrefix+'featureValue');
	featureValueField.attr('name', options.idPrefix+'featureValue');
	featureValueField.attr('type', 'text');
	featureValueField.attr('size', 50);
	
	var featureValueContainer = $('<div></div>');
	featureValueContainer.addClass('formElement');
	featureValueContainer.append(featureValueLabel);
	featureValueContainer.append(featureValueField);
	
	options.target.append(featureSelectionContainer);
	options.target.append(featureValueContainer);
}

function createMultipleStringFilterSelector(options) {
	var stringFilterDescription = $('<div></div>');
	stringFilterDescription.addClass('formFieldDescription');
	stringFilterDescription.html(options.description);
	
	var filterContainer = $('<div></div>');
	
	var numFilters = 0;
	var numFiltersField = $('<input></input>');
	numFiltersField.attr('type', 'hidden');
	numFiltersField.attr('name', options.idPrefix+'numberOfFilters');
	numFiltersField.attr('id', options.idPrefix+'numberOfFilters');
	numFiltersField.attr('value', numFilters);
	
	var addFilterButton = $('<input></input>');
	addFilterButton.attr('id', options.idPrefix+'addFilterBUtton');
	addFilterButton.attr('type', 'button');
	addFilterButton.attr('value', 'Add filter');
	addFilterButton.click(function(){
		var newFilterDiv = $('<div></div>');
		filterContainer.append(newFilterDiv);
		
		createStringFilter({
			'target' : newFilterDiv,
			'idPrefix' : options.idPrefix+'filters_'+numFilters+'_',
			'removable' : true
		});
		
		numFilters = numFilters+1;
		numFiltersField.val(numFilters);
	});
	
	var doFilterButton = $('<input></input>');
	doFilterButton.attr('type', 'button');
	doFilterButton.attr('value', 'Apply Filters');
	
	options.target.append(stringFilterDescription);
	options.target.append(filterContainer);
	options.target.append(numFiltersField);
	if (options.showFilterButton) {
		doFilterButton.click(options.onFilter);
		options.target.append(doFilterButton);
	}
	options.target.append(addFilterButton);
}

function createStringFilter(options) {
	options.target.addClass('formElement');

	var filterLabel = $('<label></label>');
	filterLabel.attr('for', options.idPrefix+'regex');
	filterLabel.html('Filter');
	
	var filterField = $('<input></input>');
	filterField.attr('id', options.idPrefix+'regex');
	filterField.attr('name', options.idPrefix+'regex');
	filterField.attr('type', 'text');
	filterField.attr('size', '50');
	
	var removeFilterButton = $('<input></input>');
	removeFilterButton.attr('type', 'button');
	removeFilterButton.attr('value', 'Remove');
	removeFilterButton.click(function() {
		$(this).parent().remove();
	});
	
	options.target.append(filterLabel);
	options.target.append(filterField);
	options.target.append(removeFilterButton);
}

function createMultipleTagSetSelector(options) {
	var tagSetDescription = $('<div></div>');
	tagSetDescription.addClass('formFieldDescription');
	tagSetDescription.html(options.description);
	
	var tagSetContainer = $('<div></div>');

	var numTags = 0;
	var numTagsField = $('<input></input>');
	numTagsField.attr('type', 'hidden');
	numTagsField.attr('name', options.idPrefix+'numberOfTagSets');
	numTagsField.attr('id', options.idPrefix+'numberOfTagSets');
	numTagsField.attr('value', numTags);
	
	var addTagSetButton = $('<input></input>');
	addTagSetButton.attr('id', options.idPrefix+'addTagSetButton');
	addTagSetButton.attr('type', 'button');
	addTagSetButton.attr('value', 'Add tag set');
	addTagSetButton.click(function() {
		var newTagSetDiv = $('<div></div>');
		tagSetContainer.append(newTagSetDiv);
		
		createTagSelector({'target' : newTagSetDiv, 'removable' : true, 'idPrefix' : options.idPrefix+'tagSet_'+numTags+'_'});
		
		numTags = numTags+1;
		numTagsField.val(numTags);
	});
	
	options.target.append(tagSetDescription);
	options.target.append(tagSetContainer);
	options.target.append(numTagsField);
	options.target.append(addTagSetButton);
}

function createTagSelector(options) {
	$.post('/hal/getFormSnippet/utilities/getDefinedTags',
		{
			'hal_httpResponseContentType' : 'json'
		},
		function(response) {
			if (response.successful) {
				options.target.addClass('formElement');

				var tagSetField = $('<input></input>');
				tagSetField.attr('id', options.idPrefix+'tagField');
				tagSetField.attr('name', options.idPrefix+'tagField');
				tagSetField.attr('type', 'text');
				tagSetField.attr('size', '50');
				
				options.target.append(tagSetField);
				
				var tagSetSelector = $('<select></select>');
				tagSetSelector.attr('id', options.idPrefix+'tagSelect');
				var emptyOption = $('<option></option>');
				emptyOption.attr('value', '');
				emptyOption.html('---Defined tags---');
				tagSetSelector.append(emptyOption);
				
				for (var i in response.result.definedTags) {
					var option = $('<option></option>');
					option.attr('value', response.result.definedTags[i]);
					option.html(response.result.definedTags[i]);
					tagSetSelector.append(option);
				}
				
				tagSetSelector.change( function() {
					var val = $(this).val();
					if (val !== '') {
						tagVal = tagSetField.val();
						if (tagVal !== '') {
							tagVal = tagVal+',';
						}
						
						tagSetField.val(tagVal+val);
					}
				} );
				
				options.target.append(tagSetSelector);
				
				if (options.removable) {
					var removeSetButton = $('<input></input>');
					removeSetButton.attr('id', options.idPrefix+'removeButton');
					removeSetButton.attr('type', 'button');
					removeSetButton.attr('value', 'Remove');
					removeSetButton.click(function() {
						$(this).parent().remove();
					});

					options.target.append(removeSetButton);
				}
			}
		},
		'json'
	);	
}

function createRealIntervalDomainSpecifics(options) {
	var d = undefined;
	if (options.parameter !== undefined) {
		if (options.parameter.hasDomain && options.parameter.domain.type === 'REAL_INTERVAL') {
			d = options.parameter.domain;
		} else if (options.parameter.hasSemanticDomain && options.parameter.semanticDomain.type === 'REAL_INTERVAL') {
			d = options.parameter.semanticDomain;
		}
	}
	
	var domainDescription = $('<div></div>');
	domainDescription.addClass('formFieldDescription');
	domainDescription.append('Use \'-Infinity\' or \'Infinity\' for infinite lower or upper bounds. If specified, default values must be numeric.');
	
	var boundsLabel = $('<label></label>');
	boundsLabel.attr('for', options.idPrefix+'lowerBound');
	boundsLabel.html('Domain bounds');
	
	var boundsContainer = $('<div></div>');
	
	var lowerBoundOpenClosed = $('<select></select>');
	lowerBoundOpenClosed.attr('id', options.idPrefix+'isLowerBoundOpen');
	lowerBoundOpenClosed.attr('name', options.idPrefix+'isLowerBoundOpen');
	
	var lowerBoundOpenOption = $('<option></option>');
	lowerBoundOpenOption.attr('value', 'true');
	lowerBoundOpenOption.html('(');
	
	var lowerBoundClosedOption = $('<option></option>');
	lowerBoundClosedOption.attr('value', 'false');
	lowerBoundClosedOption.html('[');
	
	lowerBoundOpenClosed.append(lowerBoundClosedOption);
	lowerBoundOpenClosed.append(lowerBoundOpenOption);
	
	if (d !== undefined) {
		if (d.isLowerBoundOpen) {
			lowerBoundOpenClosed.val('true');
		} else {
			lowerBoundOpenClosed.val('false');
		}
	}
	
	var lowerBoundField = $('<input></input>');
	lowerBoundField.attr('id', options.idPrefix+'lowerBound');
	lowerBoundField.attr('name', options.idPrefix+'lowerBound');
	lowerBoundField.attr('type', 'text');
	lowerBoundField.attr('size', 25);
	
	var upperBoundField = $('<input></input>');
	upperBoundField.attr('id', options.idPrefix+'upperBound');
	upperBoundField.attr('name', options.idPrefix+'upperBound');
	upperBoundField.attr('type', 'text');
	upperBoundField.attr('size', 25);
	
	if (d !== undefined) {
		lowerBoundField.val(d.lowerBound);
		upperBoundField.val(d.upperBound);
	}
	
	var upperBoundOpenClosed = $('<select></select>');
	upperBoundOpenClosed.attr('id', options.idPrefix+'isUpperBoundOpen');
	upperBoundOpenClosed.attr('name', options.idPrefix+'isUpperBoundOpen');
	
	var upperBoundOpenOption = $('<option></option>');
	upperBoundOpenOption.attr('value', 'true');
	upperBoundOpenOption.html(')');
	
	var upperBoundClosedOption = $('<option></option>');
	upperBoundClosedOption.attr('value', 'false');
	upperBoundClosedOption.html(']');
	
	upperBoundOpenClosed.append(upperBoundClosedOption);
	upperBoundOpenClosed.append(upperBoundOpenOption);
	
	if (d != undefined) {
		if (d.isUpperBoundOpen) {
			upperBoundOpenClosed.val('true');
		} else {
			upperBoundOpenClosed.val('false');
		}
	}
	
	boundsContainer.append(lowerBoundOpenClosed);
	boundsContainer.append(lowerBoundField);
	boundsContainer.append(',');
	boundsContainer.append(upperBoundField);
	boundsContainer.append(upperBoundOpenClosed);
	
	var bounds = $('<div></div>');
	bounds.addClass('formElement');
	bounds.addClass('parameterDomainSpecifics');
	bounds.append(boundsLabel);
	bounds.append(boundsContainer);
	
	options.target.append(domainDescription);
	options.target.append(bounds);
	
	if (options.showTransformationField) {
		var transformationLabel = $('<label></label>');
		transformationLabel.attr('for', options.idPrefix+'transformation');
		transformationLabel.html('Domain transformation');

		var transformationField = $('<select></select>');
		transformationField.attr('id', options.idPrefix+'transformation');
		transformationField.attr('name', options.idPrefix+'transformation');
		
		// LOG, EXP, NO_TRANSFORMATION
		var noTransformationOption = $('<option></option>');
		noTransformationOption.attr('value', 'NO_TRANSFORMATION');
		noTransformationOption.html('No transformation');
		transformationField.append(noTransformationOption);

		var logTransformationOption = $('<option></option>');
		logTransformationOption.attr('value', 'LOG');
		logTransformationOption.html('Logarithmic transformation');
		transformationField.append(logTransformationOption);

		var expTransformationOption = $('<option></option>');
		expTransformationOption.attr('value', 'EXP');
		expTransformationOption.html('Exponential transformation');
		transformationField.append(expTransformationOption);

		if (d !== undefined) {
			transformationField.val(d.transformation);
		}

		var transformation = $('<div></div>');
		transformation.addClass('formElement');
		transformation.addClass('parameterDomainSpecifics');
		transformation.append(transformationLabel);
		transformation.append(transformationField);

		options.target.append(transformation);
	}
}

function createIntegerIntervalDomainSpecifics(options) {
	var d = undefined;
	if (options.parameter !== undefined) {
		if (options.parameter.hasDomain && options.parameter.domain.type === 'INTEGER_INTERVAL') {
			d = options.parameter.domain;
		} else if (options.parameter.hasSemanticDomain && options.parameter.semanticDomain.type === 'INTEGER_INTERVAL') {
			d = options.parameter.semanticDomain;
		}
	}
	
	var domainDescription = $('<div></div>');
	domainDescription.addClass('formFieldDescription');
	domainDescription.append('Use \'-Infinity\' or \'Infinity\' for infinite lower or upper bounds. If specified, default values must be numeric.');
	
	var boundsLabel = $('<label></label>');
	boundsLabel.attr('for', options.idPrefix+'lowerBound');
	boundsLabel.html('Domain bounds');
	
	var boundsContainer = $('<div></div>');
	
	var lowerBoundField = $('<input></input>');
	lowerBoundField.attr('id', options.idPrefix+'lowerBound');
	lowerBoundField.attr('name', options.idPrefix+'lowerBound');
	lowerBoundField.attr('type', 'text');
	lowerBoundField.attr('size', 25);
	
	var upperBoundField = $('<input></input>');
	upperBoundField.attr('id', options.idPrefix+'upperBound');
	upperBoundField.attr('name', options.idPrefix+'upperBound');
	upperBoundField.attr('type', 'text');
	upperBoundField.attr('size', 25);
	
	if (d !== undefined) {
		lowerBoundField.val(d.lowerBound);
		upperBoundField.val(d.upperBound);
	}
	
	boundsContainer.append('[');
	boundsContainer.append(lowerBoundField);
	boundsContainer.append(',');
	boundsContainer.append(upperBoundField);
	boundsContainer.append(']');
	
	var bounds = $('<div></div>');
	bounds.addClass('formElement');
	bounds.addClass('parameterDomainSpecifics');
	bounds.append(boundsLabel);
	bounds.append(boundsContainer);
	
	options.target.append(domainDescription);
	options.target.append(bounds);
	
	if (options.showTransformationField) {
		var transformationLabel = $('<label></label>');
		transformationLabel.attr('for', options.idPrefix+'transformation');
		transformationLabel.html('Domain transformation');

		var transformationField = $('<select></select>');
		transformationField.attr('id', options.idPrefix+'transformation');
		transformationField.attr('name', options.idPrefix+'transformation');
		
		// LOG, EXP, NO_TRANSFORMATION
		var noTransformationOption = $('<option></option>');
		noTransformationOption.attr('value', 'NO_TRANSFORMATION');
		noTransformationOption.html('No transformation');
		transformationField.append(noTransformationOption);

		var logTransformationOption = $('<option></option>');
		logTransformationOption.attr('value', 'LOG');
		logTransformationOption.html('Logarithmic transformation');
		transformationField.append(logTransformationOption);

		var expTransformationOption = $('<option></option>');
		expTransformationOption.attr('value', 'EXP');
		expTransformationOption.html('Exponential transformation');
		transformationField.append(expTransformationOption);

		if (d !== undefined) {
			transformationField.val(d.transformation);
		}

		var transformation = $('<div></div>');
		transformation.addClass('formElement');
		transformation.addClass('parameterDomainSpecifics');
		transformation.append(transformationLabel);
		transformation.append(transformationField);

		options.target.append(transformation);
	}
}

function createBooleanDomainSpecifics(options) {
	var d = undefined;
	if (options.parameter !== undefined) {
		if (options.parameter.hasDomain && options.parameter.domain.type === 'BOOLEAN') {
			d = options.parameter.domain;
		} else if (options.parameter.hasSemanticDomain && options.parameter.semanticDomain.type === 'BOOLEAN') {
			d = options.parameter.semanticDomain;
		}
	}
	
	var domainDescription = $('<div></div>');
	domainDescription.addClass('formFieldDescription');
	domainDescription.append('');
	
	var booleanRegexFieldLabel = $('<label></label>');
	booleanRegexFieldLabel.attr('for', options.idPrefix+'regex');
	booleanRegexFieldLabel.html('Regular expression to match true (optional)');
	
	var booleanRegexField = $('<input></input>');
	booleanRegexField.attr('id', options.idPrefix+'regex');
	booleanRegexField.attr('name', options.idPrefix+'regex');
	booleanRegexField.attr('type', 'text');
	booleanRegexField.attr('size', 75);
	
	if (d !== undefined) {
		booleanRegexField.val(d.regex);
	}
	
	var regexContainer = $('<div></div>');
	regexContainer.addClass('formElement');
	regexContainer.addClass('parameterDomainSpecifics');
	regexContainer.append(booleanRegexFieldLabel);
	regexContainer.append(booleanRegexField);
	
	var booleanInvertedFieldLabel = $('<label></label>');
	booleanInvertedFieldLabel.attr('for', options.idPrefix+'isInverted');
	booleanInvertedFieldLabel.html('Use the complement?');
	
	var booleanInvertedField = $('<input></input>');
	booleanInvertedField.attr('id', options.idPrefix+'isInverted');
	booleanInvertedField.attr('name', options.idPrefix+'isInverted');
	booleanInvertedField.attr('type', 'checkbox');
	
	if (d !== undefined) {
		if (d.isInverted) {
			booleanInvertedField.attr('checked', 'on');
		}
	}
	
	var invertedContainer = $('<div></div>');
	invertedContainer.addClass('formElement');
	invertedContainer.addClass('parameterDomainSpecifics');
	invertedContainer.append(booleanInvertedFieldLabel);
	invertedContainer.append(booleanInvertedField);
	
	options.target.append(domainDescription);
	options.target.append(regexContainer);
	options.target.append(invertedContainer);
}
 
function createStringDomainSpecifics(options) {
	var d = undefined;
	if (options.parameter !== undefined) {
		if (options.parameter.hasDomain && options.parameter.domain.type === 'STRING') {
			d = options.parameter.domain;
		} else if (options.parameter.hasSemanticDomain && options.parameter.semanticDomain.type === 'STRING') {
			d = options.parameter.semanticDomain;
		}
	}
	
	var domainDescription = $('<div></div>');
	domainDescription.addClass('formFieldDescription');
	domainDescription.append('');
	
	var stringRegexLabel = $('<label></label>');
	stringRegexLabel.attr('for', options.idPrefix+'regex');
	stringRegexLabel.html('Regular expression for allowable strings');
	
	var stringRegexField = $('<input></input>');
	stringRegexField.attr('id', options.idPrefix+'regex');
	stringRegexField.attr('name', options.idPrefix+'regex');
	stringRegexField.attr('type', 'text');
	stringRegexField.attr('size', 50);

	if (d !== undefined) {
		stringRegexField.val(d.regex);
	}
	
	var stringDomainRegexContainer = $('<div></div>');
	stringDomainRegexContainer.addClass('formElement');
	stringDomainRegexContainer.addClass('parameterDomainSpecifics');
	stringDomainRegexContainer.append(stringRegexLabel);
	stringDomainRegexContainer.append(stringRegexField);
	
	options.target.append(domainDescription);
	options.target.append(stringDomainRegexContainer);
}

function createCategoricalDomainSpecifics(options) {
	var d = undefined;
	if (options.parameter !== undefined) {
		if (options.parameter.hasDomain && options.parameter.domain.type === 'CATEGORICAL') {
			d = options.parameter.domain;
		} else if (options.parameter.hasSemanticDomain && options.parameter.semanticDomain.type === 'CATEGORICAL') {
			d = options.parameter.semanticDomain;
		}
	}
	
	var domainDescription = $('<div></div>');
	domainDescription.addClass('formFieldDescription');
	domainDescription.append('');
	
	var categoricalValuesLabel = $('<label></label>');
	categoricalValuesLabel.attr('for', options.idPrefix+'values');
	categoricalValuesLabel.html('Domain values, comma-separated. Strings must be double-quoted');
	
	var categoricalValuesField = $('<input></input>');
	categoricalValuesField.attr('id', options.idPrefix+'values');
	categoricalValuesField.attr('name', options.idPrefix+'values');
	categoricalValuesField.attr('type', 'text');
	categoricalValuesField.attr('size', 75);
	
	if (d !== undefined) {
		var v = '';
		var first = true;
		for (var i in d.values) {
			if (!first) {
				v = v+',';
			} else {
				first = false;
			}
			
			v = v+d.values[i];
		}
	}
	
	var categoricalValues = $('<div></div>');
	categoricalValues.addClass('formElement');
	categoricalValues.addClass('parameterDomainSpecifics');
	categoricalValues.append(categoricalValuesLabel);
	categoricalValues.append(categoricalValuesField);
	
	options.target.append(domainDescription);
	options.target.append(categoricalValues);
}

function createFileDomainSpecifics(options) {
	var d = undefined;
	if (options.parameter !== undefined) {
		if (options.parameter.hasDomain && options.parameter.domain.type === 'FILE') {
			d = options.parameter.domain;
		} else if (options.parameter.hasSemanticDomain && options.parameter.semanticDomain.type === 'FILE') {
			d = options.parameter.semanticDomain;
		}
	}
	
	var domainDescription = $('<div></div>');
	domainDescription.addClass('formFieldDescription');
	domainDescription.append('');
	
	var filePathRestrictionsLabel = $('<label></label>');
	filePathRestrictionsLabel.attr('for', options.idPrefix+'filePathRestrictions');
	filePathRestrictionsLabel.html('File path restrictions');
	
	var filePathRestrictionsField = $('<select></select>');
	filePathRestrictionsField.attr('id', options.idPrefix+'filePathRestrictions');
	filePathRestrictionsField.attr('name', options.idPrefix+'filePathRestrictions');
	
	var anyFileRestriction = $('<option></option>');
	anyFileRestriction.attr('value', 'ANY');
	anyFileRestriction.html('Any valid path');
	filePathRestrictionsField.append(anyFileRestriction);
	
	var fileExistsRestriction = $('<option></option>');
	fileExistsRestriction.attr('value', 'EXISTS');
	fileExistsRestriction.html('Files that actually exist');
	filePathRestrictionsField.append(fileExistsRestriction);

	if (d !== undefined) {
		filePathRestrictionsField.val(d.filePathRestrictions);
	}
	
	var filePathRestrictions = $('<div></div>');
	filePathRestrictions.addClass('formElement');
	filePathRestrictions.addClass('parameterDomainSpecifics');
	filePathRestrictions.append(filePathRestrictionsLabel);
	filePathRestrictions.append(filePathRestrictionsField);
	
	options.target.append(domainDescription);
	options.target.append(filePathRestrictions);
}

function createParameterDomainInputSpecifics(options) {
	if ("REAL_INTERVAL" === options.domainType) {
		createRealIntervalDomainSpecifics(options);
	} else if ("INTEGER_INTERVAL" === options.domainType) {
		createIntegerIntervalDomainSpecifics(options);
	} else if ("BOOLEAN" === options.domainType) {
		createBooleanDomainSpecifics(options);
	} else if ("STRING" === options.domainType) {
		createStringDomainSpecifics(options);
	} else if ("CATEGORICAL" === options.domainType) {
		createCategoricalDomainSpecifics(options);
	} else if ("FILE" === options.domainType) {
		createFileDomainSpecifics(options);
	}
}

function createDomainDefaultValueInput(options) {
	var d = undefined;
	if (options.parameter !== undefined) {
		if (options.parameter.hasDomain && options.parameter.domain.type === options.domainType) {
			d = options.parameter.domain;
		} else if (options.parameter.hasSemanticDomain && options.parameter.semanticDomain.type === options.domainType) {
			d = options.parameter.semanticDomain;
		}
	}
	
	var defaultValueLabel = $('<label></label>');
	defaultValueLabel.attr('for', options.idPrefix+'defaultValue');
	defaultValueLabel.html('Default value');
	
	var defaultValueField;
	if (options.domainType === 'BOOLEAN') {
		defaultValueField = $('<select></select>');
		defaultValueField.attr('id', options.idPrefix+'defaultValue');
		defaultValueField.attr('name', options.idPrefix+'defaultValue');
		
		var trueOption = $('<option></option>');
		trueOption.attr('value', 'true');
		trueOption.html('true');
		defaultValueField.append(trueOption);
		
		var falseOption = $('<option></option>');
		falseOption.attr('value', 'false');
		falseOption.html('false');
		defaultValueField.append(falseOption);
		
		if (d !== undefined && d.hasDefaultValue) {
			if (d.defaultValue) {
				defaultValueField.val('true');
			} else {
				defaultValueField.val('false');
			}
		}
	} else {
		defaultValueField = $('<input></input>');
		defaultValueField.attr('id', options.idPrefix+'defaultValue');
		defaultValueField.attr('name', options.idPrefix+'defaultValue');
		defaultValueField.attr('type', 'text');
		defaultValueField.attr('size', 75);
		
		if (d !== undefined && d.hasDefaultValue) {
			defaultValueField.val(d.defaultValue);
		}
	}
	
	var defaultValue = $('<div></div>');
	defaultValue.addClass('formElement');
	defaultValue.addClass('parameterDomainSpecifics');
	defaultValue.append(defaultValueLabel);
	defaultValue.append(defaultValueField);
	
	options.target.append(defaultValue);
}

function createParameterDomainSpecification(options) {
	var domainTypeLabel = $('<label></label>');
	domainTypeLabel.attr('for', options.idPrefix+'domainType');
	domainTypeLabel.html('Domain type');
	
	var domainSpecifics = $('<div></div>');

	var domainTypeField = $('<select></select>');
	domainTypeField.attr('id', options.idPrefix+'domainType');
	domainTypeField.attr('name', options.idPrefix+'domainType');
	
	var domainOptions = {
			'REAL_INTERVAL' : 'Real interval',
			'INTEGER_INTERVAL' : 'Integer interval',
			'BOOLEAN' : 'Boolean',
			'STRING' : 'String',
			'CATEGORICAL' : 'Categorical',
			'FILE' : 'File'
	};
	
	for (var i in domainOptions) {
		var opt = $('<option></option>');
		opt.attr('value', i);
		opt.html(domainOptions[i]);
		
		domainTypeField.append(opt);
	}
	
	domainTypeField.change(function() {
		domainSpecifics.html('');
		
		var domainSpecificsContainer = $('<div></div>');
		domainSpecifics.append(domainSpecificsContainer);
		
		createParameterDomainInputSpecifics({
			'target' : domainSpecificsContainer,
			'domainType' : domainTypeField.val(),
			'parameter' : options.parameter,
			'showTransformationField' : options.showTransformationField,
			'idPrefix' : options.idPrefix
		});
		
		if (options.showDefaultValueField) {
			var domainDefaultValue = $('<div></div>');
			domainSpecifics.append(domainDefaultValue);
			createDomainDefaultValueInput({
				'target' : domainDefaultValue,
				'domainType' : domainTypeField.val(),
				'parameter' : options.parameter,
				'idPrefix' : options.idPrefix,
				'showDefaultValueField' : options.showDefaultValueField
			});
		}
	});
	
	if (options.parameter !== undefined) {
		if (options.parameter.hasDomain) {
			domainTypeField.val(options.parameter.domain.type);
		} else if (options.parameter.hasSemanticDomain) {
			domainTypeField.val(options.parameter.semanticDomain.type);
		}
	}
	
	domainTypeField.change();
	
	var domainTypeContainer = $('<div></div>');
	domainTypeContainer.addClass('formElement');
	domainTypeContainer.append(domainTypeLabel);
	domainTypeContainer.append(domainTypeField);
	
	options.target.addClass('parameterDomainSpecification');
	options.target.append(domainTypeContainer);
	options.target.append(domainSpecifics);
}

function createParameterField(options) {
	var parameterName = $('<span></span>');
	parameterName.addClass('parameterName');
	parameterName.append(options.parameter.name);
	if (options.parameter.isOptional) {
		parameterName.append(' (optional)');
	}
	
	var parameterNameLink = $('<a></a>');
	parameterNameLink.append(parameterName);
	
	var parameterHeader = $('<div></div>');
	parameterHeader.addClass('expanded');
	parameterHeader.append(parameterNameLink);
	
	var parameterContent = $('<div></div>');
	parameterContent.addClass('collapsibleContent');
	
	var parameterContainer = $('<div></div>');
	parameterContainer.addClass('collapsible');
	
	parameterContainer.append(parameterHeader);
	parameterContainer.append(parameterContent);
	
	collapsible(parameterContainer);
	
	var parameterDomainSpecification = $('<div></div>');
	
	var parameterSemanticsSpecification = $('<div></div>');
	if (options.showSemanticsSelector) {
		parameterSemanticsSpecification.addClass('parameterSemantics');
		
		var semanticsSelectionLabel = $('<label></label>');
		semanticsSelectionLabel.attr('for', options.idPrefix+'semantics');
		semanticsSelectionLabel.html('Semantics');
		
		var semanticsSelection = $('<select></select>');
		semanticsSelection.attr('id', options.idPrefix+'semantics');
		semanticsSelection.attr('name', options.idPrefix+'semantics');
		
		for (var i in options.semanticsOptions) {
			var opt = $('<option></option>');
			opt.attr('value', i);
			opt.html(options.semanticsOptions[i].humanReadableName);
			
			semanticsSelection.append(opt);
		}
		
		semanticsSelection.change(function() {
			// initialise the domain specification to the right defaults.
			// previously-specified domain information in the JSON object prevails,
			// but if it isn't present, use the default domain information from the 
			// semantics object.
			var sem = options.semanticsOptions[$(this).val()];
			if (!options.parameter.hasDomain && sem.hasDomain) {
				options.parameter.hasSemanticDomain = true;
				options.parameter.semanticDomain = sem.domain;
			}
			
			parameterDomainSpecification.html('');
			
			createParameterDomainSpecification({
				'target' : parameterDomainSpecification,
				'parameter' : options.parameter,
				'idPrefix' : options.idPrefix,
				'showDefaultValueField' : options.showDefaultValueField,
				'showTransformationField' : options.showTransformationField
			});
		} );

		if (options.parameter.hasSemantics) {
			semanticsSelection.val(options.parameter.semantics);
		}
		
		semanticsSelection.change();
		
		parameterSemanticsSpecification.append(semanticsSelectionLabel);
		parameterSemanticsSpecification.append(semanticsSelection);
	} else {
		// initialise the domain specification to empty, unless there is previously
		// specified information in the JSONObject.
		createParameterDomainSpecification({
			'target' : parameterDomainSpecification,
			'parameter' : options.parameter,
			'idPrefix' : options.idPrefix,
			'showDefaultValueField' : options.showDefaultValueField,
			'showTransformationField' : options.showTransformationField
		});
	}
	
	parameterContent.append(parameterSemanticsSpecification);
	parameterContent.append(parameterDomainSpecification);
	
	options.target.addClass('parameterSpecification');
	options.target.append(parameterContainer);
}

function createOutputStringField(options) {
	options.target.addClass('formElement');
	
	var outputTypeLabel = $('<label></label>');
	outputTypeLabel.attr('for', options.idPrefix+'outputTypeField');
	outputTypeLabel.html('Output source');
	
	options.target.append(outputTypeLabel);
	
	var outputTypeField = $('<select></select>');
	outputTypeField.attr('id', options.idPrefix+'outputTypeField');
	outputTypeField.attr('name', options.idPrefix+'outputTypeField');
	
	var stdOutOption = $('<option></option>');
	stdOutOption.attr('value', 'stdout');
	stdOutOption.html('stdout');
	
	var stdErrOption = $('<option></option>');
	stdErrOption.attr('value', 'stderr');
	stdErrOption.html('stderr');
	
	var bothStdOutAndErrOption = $('<option></option>');
	bothStdOutAndErrOption.attr('value', 'stdoutanderr');
	bothStdOutAndErrOption.html('stdout and stderr');
	
	outputTypeField.append(stdOutOption);
	outputTypeField.append(stdErrOption);
	outputTypeField.append(bothStdOutAndErrOption);
	
	options.target.append(outputTypeField);
	
	var outputStringLabel = $('<label></label');
	outputStringLabel.attr('for', options.idPrefix+'outputStringField');
	outputStringLabel.html('Output string');
	
	options.target.append(outputStringLabel);
	
	var outputStringField = $('<input></input>');
	outputStringField.attr('id', options.idPrefix+'outputStringField');
	outputStringField.attr('name', options.idPrefix+'outputStringField');
	outputStringField.attr('type', 'text');
	outputStringField.attr('size', '100');
	
	options.target.append(outputStringField);
	
	if (options.removable) {
		var removeOutputStringButton = $('<input></input>');
		removeOutputStringButton.attr('id', options.idPrefix+'removeOutputStringButton');
		removeOutputStringButton.attr('type', 'button');
		removeOutputStringButton.attr('value', 'Remove');
		removeOutputStringButton.click(function() {
			$(this).parent().remove();
		} );
		
		options.target.append(removeOutputStringButton);
	}
}

function initialiseReadyToLaunchRunStatus(object, statusObj) {
	var id = statusObj.id;
	var name = statusObj.name;
	
	id.match(/readyToLaunch_([0-9]*)/);
	id = RegExp.$1
	
	var nameDiv = $('<div></div>');
	nameDiv.addClass('launchRunName');
	nameDiv.html(name);
	
	var launchButtonImage = $('<img>');
	launchButtonImage.attr('src', '/hal/commands/getFile/web/icons/control_play.png');
	launchButtonImage.attr('alt', 'Launch run');
	
	var launchButtonLink = $('<a></a>');
	launchButtonLink.append(launchButtonImage);
	
	var launchButton = $('<div></div>');
	launchButton.addClass('launchRun');
	launchButton.attr('id', 'launchRun_'+id);
	launchButton.append(launchButtonLink);
	
	launchButton.hover(function() {
			launchButtonImage.attr('src', '/hal/commands/getFile/web/icons/control_play_blue.png');
		}, function() {
			launchButtonImage.attr('src', '/hal/commands/getFile/web/icons/control_play.png');
		}
	);
	
	var deleteRunImage = $('<img></img>');
	deleteRunImage.attr('src', '/hal/commands/getFile/web/icons/bin_closed.png');
	deleteRunImage.attr('alt', 'Delete run');
	
	var deleteRunLink = $('<a></a>');
	deleteRunLink.append(deleteRunImage);
	
	var deleteButton = $('<div></div>');
	deleteButton.addClass('deleteRun');
	deleteButton.append(deleteRunLink);
	
	deleteButton.hover(function() {
			deleteRunImage.attr('src', '/hal/commands/getFile/web/icons/bin_empty.png');
		}, function() {
			deleteRunImage.attr('src', '/hal/commands/getFile/web/icons/bin_closed.png');
		}
	);
	
	var deleteDetails = $('<div></div>');
	deleteDetails.addClass('deleteRunDetails');
	deleteDetails.hide();
	
	var deleteConfirmText = $('<span></span>');
	deleteConfirmText.html('Delete specified run?');
	
	var deleteConfirmYesButton = $('<input></input>');
	deleteConfirmYesButton.attr('type', 'button');
	deleteConfirmYesButton.attr('value', 'Yes');
	
	var deleteConfirmNoButton = $('<input></input>');
	deleteConfirmNoButton.attr('type', 'button');
	deleteConfirmNoButton.attr('value', 'No');
	
	deleteConfirmYesButton.click(function() {
		launchSpinner.show();
		
		$.post('/hal/getFormSnippet/runStatusMonitoring/deleteRun',
			{
				'runId' : statusObj.id,
				'hal_httpResponseContentType' : 'json'
			},
			function(response) {
				if (response.successful) {
				} else {
					launchSpinner.hide();
				}
				
				deleteDetails.slideUp();
			},
			'json'
		);
	} );
	
	deleteConfirmNoButton.click(function() {
		deleteDetails.slideUp();
	} );

	deleteDetails.append(deleteConfirmText);
	deleteDetails.append(deleteConfirmYesButton);
	deleteDetails.append(deleteConfirmNoButton);
	
	var launchSpinnerImage = $('<img></img>');
	launchSpinnerImage.attr('src', '/hal/commands/getFile/web/icons/ajax-loader-small.gif');
	var launchSpinner = $('<div></div>');
	launchSpinner.hide();
	launchSpinner.addClass('runStatusSpinner');
	launchSpinner.append(launchSpinnerImage);
	
	var launchDetails = $('<div></div>');
	launchDetails.addClass('launchRunDetails');
	launchDetails.hide();
	launchDetails.attr('id', 'launchRunDetails_'+id);
	
	deleteButton.click(function() {
		launchDetails.slideUp();
		deleteDetails.slideDown();
	});
	
	launchButton.click(function() {
		deleteDetails.slideUp();
		launchDetails.slideDown();
	} );
	
	var newNameField = $('<div></div>');
	newNameField.addClass('formElement');
	
	var newNameLabel = $('<label></label>');
	newNameLabel.attr('for', 'launchRunName_'+id);
	newNameLabel.html('Experiment name');
	
	var newNameInput = $('<input></input>');
	newNameInput.attr('type', 'text');
	newNameInput.attr('size', 50);
	newNameInput.attr('id', 'launchRunName_'+id);
	newNameInput.attr('value', name);
	
	newNameField.append(newNameLabel);
	newNameField.append(newNameInput);
	
	var newEnvironmentField = $('<div></div>');
	newEnvironmentField.addClass('formElement');
	
	var newEnvironmentLabel = $('<label></label>');
	newEnvironmentLabel.attr('for', 'launchRunEnvironment_'+id);
	newEnvironmentLabel.html('Execution environment');

	var newEnvironmentSelector = $('<select></select>');
	newEnvironmentSelector.attr('id', 'launchRunEnvironment_'+id);
	newEnvironmentSelector.append('<option value=\"\"></option>');
	
	newEnvironmentField.append(newEnvironmentLabel);
	newEnvironmentField.append(newEnvironmentSelector);
	$.post('/hal/getFormSnippet/utilities/getExecutionEnvironmentNames',
		{
			'hal_httpResponseContentType' : 'json'
		},
		function(response) {
			if (response.successful) {
				for (var name in response.result.executionEnvironmentNames) {
					newEnvironmentSelector.append('<option value=\"'+response.result.executionEnvironmentNames[name]+'\">'+response.result.executionEnvironmentNames[name]+'</option>');
				}
			}
		},
		'json'
	);
	
	
	var detailsFieldSet = $('<fieldset></fieldset>');
	detailsFieldSet.addClass('launchRunDetailsFieldGroup');
	detailsFieldSet.append(newNameField);
	detailsFieldSet.append(newEnvironmentField);
	
	var launchRunButton = $('<input></input>');
	launchRunButton.attr('type', 'button');
	launchRunButton.attr('id', 'launchRunButton_'+id);
	launchRunButton.attr('value', 'Launch');
	launchRunButton.click(function() {
		launchSpinner.show();
		deleteButton.hide();
		$.post('/hal/getFormSnippet/runStatusMonitoring/launchRun',
			{ 
				'runId' : id, 
				'runName' : newNameInput.val(),
				'runEnvironment' : newEnvironmentSelector.val(),
				'hal_httpResponseContentType' : 'json'
			},
			function(response) {
				if (!response.successful) {
					launchSpinner.hide();
					deleteButton.show();
				} else {
					launchDetails.slideUp();
				}
			},
			'json'
		);
	} );
	
	var cancelButton = $('<input></input>');
	cancelButton.attr('type', 'button');
	cancelButton.attr('id', 'cancelLaunchRunButton_'+id);
	cancelButton.attr('value', 'Cancel');
	cancelButton.click(function() {
		launchDetails.slideUp();
	} );
	
	var launchButtonsDiv = $('<div></div>');
	
	launchButtonsDiv.append(launchRunButton);
	launchButtonsDiv.append(cancelButton);
	
	launchDetails.append(detailsFieldSet);
	launchDetails.append(launchButtonsDiv);
	
	object.append(nameDiv);
	object.append(launchButton);
	object.append(deleteButton);
	object.append(launchSpinner);
	object.append(launchDetails);
	object.append(deleteDetails);
	object.append($('<div></div>'));
}

function initialiseRunningRunStatus(object, statusObj) {
	var id = statusObj.id;
	var name = statusObj.name;

	var nameLink = $('<a></a>');
	nameLink.attr('href', '/hal/monitorRun?runId='+id);
	nameLink.html(name);
	
	var nameDiv = $('<div></div>');
	nameDiv.addClass('runName');
	nameDiv.append(nameLink);
	
	var percentageComplete = statusObj.percentageComplete;
	var progressBar = $('<div></div>');
	progressBar.addClass('runProgressBar');
	progressBar.attr('id', 'runPercentageComplete_'+id);
	var barOptions = {
			steps : 100,
			width : 120,
			showText : false,
			boxImage : '/hal/commands/getFile/web/icons/progressbar.gif',
			barImage : '/hal/commands/getFile/web/icons/progressbg_halBlue.gif'
	};
	
	progressBar.progressBar(parseInt(percentageComplete), barOptions);
	
	var progressBarText = $('<div></div>');
	progressBarText.addClass('progressBarText');
	progressBarText.attr('id', 'runPercentageCompleteText_'+id);
	progressBarText.html(percentageComplete.toFixed(3)+'%');
	
	var abortButton = $('<div></div>');
	abortButton.addClass('abortRun');
	abortButton.attr('id', 'abortRun_'+id);
	
	var abortButtonImage = $('<img>');
	abortButtonImage.attr('src', '/hal/commands/getFile/web/icons/control_stop.png');
	abortButtonImage.attr('alt', 'Abort run');
	
	var abortButtonLink = $('<a></a>');
	abortButtonLink.append(abortButtonImage);
	
	abortButton.append(abortButtonLink);
	
	abortButton.hover(function() {
			abortButtonImage.attr('src', '/hal/commands/getFile/web/icons/control_stop_blue.png');
		}, function() {
			abortButtonImage.attr('src', '/hal/commands/getFile/web/icons/control_stop.png');
		}
	);
	
	var abortSpinnerImage = $('<img></img>');
	abortSpinnerImage.attr('src', '/hal/commands/getFile/web/icons/ajax-loader-small.gif');
	var abortSpinner = $('<div></div>');
	abortSpinner.addClass('runStatusSpinner');
	abortSpinner.hide();
	abortSpinner.append(abortSpinnerImage);
	
	var abortConfirmText = $('<span></span>');
	abortConfirmText.html('Abort?');
	
	var abortConfirmYesButton = $('<input></input>');
	abortConfirmYesButton.attr('type', 'button');
	abortConfirmYesButton.attr('value', 'Yes');
	abortConfirmYesButton.attr('id', 'abortConfirmYesButton_'+id);
	
	var abortConfirmNoButton = $('<input></input>');
	abortConfirmNoButton.attr('type', 'button');
	abortConfirmNoButton.attr('value', 'No');
	abortConfirmNoButton.attr('id', 'abortConfirmNoButton_'+id);
	
	var abortConfirm = $('<div></div>');
	abortConfirm.addClass('abortConfirm');
	abortConfirm.hide();
	abortConfirm.append(abortConfirmText);
	abortConfirm.append(abortConfirmYesButton);
	abortConfirm.append(abortConfirmNoButton);
	
	abortConfirmYesButton.click(function() {
		abortSpinner.show();
		
		$.post('/hal/getFormSnippet/runStatusMonitoring/abortRun',
			{
				'runId' : id,
				'hal_httpResponseContentType' : 'json'
			},
			function(response) {
				if (response.successful) {
				} else {
					abortSpinner.hide();
				}
				
				abortConfirm.hide();
				abortButton.show();
			},
			'json'
		);
	} );
	
	abortConfirmNoButton.click(function() {
		abortConfirm.hide();
		abortButton.show();
	} );

	abortButton.click(function() {
		abortSpinner.hide();
		abortButton.hide();
		abortConfirm.show();
	} );
	
	var progressBarPlusButtons = $('<div></div>');  
    if (percentageComplete < 0) {
        var errorText = $('<div></div>');
        errorText.addClass('launchRunName');
        errorText.attr('id', 'errorText_'+id);
        errorText.html('(error connecting to host for status)');
        progressBarPlusButtons.append(errorText);
        addDeleteControls(progressBarPlusButtons, statusObj);
        progressBar.hide();
        progressBarText.hide();
        abortButton.hide();
    } 
    progressBarPlusButtons.append(progressBar);
	progressBarPlusButtons.append(progressBarText);
	progressBarPlusButtons.append(abortButton);
	progressBarPlusButtons.append(abortSpinner);
	progressBarPlusButtons.append(abortConfirm);
	
	object.append(nameDiv);
	object.append(progressBarPlusButtons);
}

function initialiseQueuedRunStatus(object, statusObj) {
	var id = statusObj.id;
	var name = statusObj.name;

	var nameDiv = $('<div></div>');
	nameDiv.addClass('runName');
	nameDiv.append(name);
	
	object.append(nameDiv);
}

function initialiseFinishedOrTerminatedRunStatus(object, statusObj) {
	var id = statusObj.id;
	var name = statusObj.name;

	var nameLink = $('<a></a>');
	nameLink.attr('href', '/hal/monitorRun?runId='+id);
	nameLink.html(name);
	
	var nameDiv = $('<div></div>');
	nameDiv.addClass('finishedRunName');
	nameDiv.append(nameLink);
	
	object.append(nameDiv);
    addDeleteControls(object, statusObj);
}

function addDeleteControls(object, statusObj) {
	var id = statusObj.id;
	var name = statusObj.name;

	var deleteRunImage = $('<img></img>');
	deleteRunImage.attr('src', '/hal/commands/getFile/web/icons/bin_closed.png');
	deleteRunImage.attr('alt', 'Delete run');
	
	var deleteRunLink = $('<a></a>');
	deleteRunLink.append(deleteRunImage);
	
	var deleteRun = $('<div></div>');
	deleteRun.addClass('deleteRun');
	deleteRun.append(deleteRunLink);
	
	deleteRun.hover(function() {
			deleteButtonImage.attr('src', '/hal/commands/getFile/web/icons/bin_empty.png');
		}, function() {
			deleteButtonImage.attr('src', '/hal/commands/getFile/web/icons/bin_closed.png');
		}
	);
	
	var deleteSpinnerImage = $('<img></img>');
	deleteSpinnerImage.attr('src', '/hal/commands/getFile/web/icons/ajax-loader-small.gif');
	var deleteSpinner = $('<div></div>');
	deleteSpinner.addClass('runStatusSpinner');
	deleteSpinner.hide();
	deleteSpinner.append(deleteSpinnerImage);
	
	var deleteConfirmText = $('<span></span>');
	deleteConfirmText.html('Delete?');
	
	var deleteConfirmYesButton = $('<input></input>');
	deleteConfirmYesButton.attr('type', 'button');
	deleteConfirmYesButton.attr('value', 'Yes');
	deleteConfirmYesButton.attr('id', 'deleteConfirmYesButton_'+id);
	
	var deleteConfirmNoButton = $('<input></input>');
	deleteConfirmNoButton.attr('type', 'button');
	deleteConfirmNoButton.attr('value', 'No');
	deleteConfirmNoButton.attr('id', 'deleteConfirmNoButton_'+id);
	
	var deleteConfirm = $('<div></div>');
	deleteConfirm.addClass('deleteConfirm');
	deleteConfirm.hide();
	deleteConfirm.append(deleteConfirmText);
	deleteConfirm.append(deleteConfirmYesButton);
	deleteConfirm.append(deleteConfirmNoButton);
	
	deleteConfirmYesButton.click(function() {
		deleteSpinner.show();
		
		$.post('/hal/getFormSnippet/runStatusMonitoring/deleteRun',
			{
				'runId' : id,
				'hal_httpResponseContentType' : 'json'
			},
			function(response) {
				if (response.successful) {
				} else {
					deleteSpinner.hide();
				}
				
				deleteConfirm.hide();
				deleteRun.show();
			},
			'json'
		);
	} );
	
	deleteConfirmNoButton.click(function() {
		deleteConfirm.hide();
		deleteRun.show();
	} );
	
	deleteRun.click(function() {
		deleteSpinner.hide();
		deleteRun.hide();
		deleteConfirm.show();
	} );
    
    object.append(deleteRun);
	object.append(deleteSpinner);
	object.append(deleteConfirm);
}

function initialiseRunStatus(object, statusObj) {
	var status = statusObj.status;

	if (status === 'readyToLaunch') {
		initialiseReadyToLaunchRunStatus(object, statusObj);
	} else if (status === 'running') {
		initialiseRunningRunStatus(object, statusObj);
	} else if (status === 'queued') {
		initialiseQueuedRunStatus(object, statusObj);
	} else if (status === 'finished' || status === 'terminatedByUser' || status === 'terminatedAbnormally') {
		initialiseFinishedOrTerminatedRunStatus(object, statusObj);
	}
}

function updateRunningRunStatus(object, statusObj) {
	var id = statusObj.id;
	var name = statusObj.name;
	var percentageComplete = statusObj.percentageComplete;
	
	var barOptions = {
			steps : 100,
			width : 120,
			showText : false,
			boxImage : '/hal/commands/getFile/web/icons/progressbar.gif',
			barImage : '/hal/commands/getFile/web/icons/progressbg_halBlue.gif'
	};
	
	$('#runPercentageComplete_'+id).progressBar(parseInt(percentageComplete), barOptions);
	$('#runPercentageCompleteText_'+id).html(percentageComplete.toFixed(3)+'%');
}

function updateRunStatus(object, statusObj) {
	var status = statusObj.status;
	
	if (status === 'readyToLaunch') {
		
	} else if (status === 'running') {
		updateRunningRunStatus(object, statusObj);
	} else if (status === 'queued') {
		
	} else if (status === 'finished' || status === 'terminatedByUser' || status === 'terminatedAbnormally') {
		
	}
}